/*
 * Created by wangshengye on 2020/05/07.
 *
 */
/*
 * Changed by wangzeyu on 2020/12/22.
 *
 */
#ifndef ELF_SIGN_H
#define ELF_SIGN_H

#include <stdbool.h>

#ifdef __cplusplus
extern "C" {
#endif


/*
 * @function:     elf文件签名函数
 * @input param:  elfPath elf文件路径
 * @
 * @return        true 签名成功，false 签名失败
 */
bool elf_signature(const char *elfPath,const char *certPath,const char *keyPath);

/*
 * @function:     elf文件签名验证函数
 * @input param:  elfPath elf文件路径
 * @return        true 验签成功，false 验签失败
 */
bool elf_verify(const char *elfPath);
/*
 * @function:     elf文件签名删除函数
 * @input param:  elfPath elf文件路径
 * @return        true 删除成功，false 删除失败
 */
bool elf_delete(const char *elfPath);

/*
 * @function:     rpm包中elf文件签名、删除函数
 * @input param:  pkgPath rpm文件路径
 *                certPath 证书路径
 *                keyPath  密钥路径
 *                option   1 删除rpm中elf文件签名 ; 0 为rpm中elf文件添加签名
 * @return        0 签名/删除签名成功，-1 签名/删除签名失败
 */
int pkg_elf_signature(const char *pkgPath,const char *certPath,const char *keyPath,int option);

#ifdef __cplusplus
}
#endif

#endif //ELF_SIGN_
